import React, { useState, useEffect } from 'react';
import { Pagination } from 'react-bootstrap';
import 'bootstrap/dist/css/bootstrap.min.css';

var PaginationPlus = function PaginationPlus(props) {
  if (typeof props.total === 'undefined' || typeof props.pageSize === 'undefined') {
    return /*#__PURE__*/React.createElement("p", null, "Props total and pageSize can't be empty.");
  }

  var _useState = useState(props.currentPage ? props.currentPage - 1 : 1),
      currentPage = _useState[0],
      setCurrentPage = _useState[1];

  var _useState2 = useState([]),
      pagiItems = _useState2[0],
      setPagiItems = _useState2[1];

  var numOfPage = Math.ceil(props.total / props.pageSize);

  var handleChange = function handleChange(e) {
    if (typeof e.target.text !== 'undefined' && parseInt(e.target.text) - 1 !== currentPage) {
      setCurrentPage(parseInt(e.target.text) - 1);

      if (typeof props.onChange !== 'undefined') {
        props.onChange(parseInt(e.target.text));
      }
    }
  };

  var updateCurrentPage = function updateCurrentPage(page) {
    setCurrentPage(page);

    if (typeof props.onChange !== 'undefined') {
      props.onChange(page + 1);
    }
  };

  var populatePageItems = function populatePageItems() {
    if (numOfPage < 6) {
      setPagiItems(Array.from(Array(numOfPage), function (e, i) {
        return i;
      }));
    } else {
      if (currentPage < 3) {
        var tempPagiItems = Array.from(Array(6), function (e, i) {
          return i;
        });
        tempPagiItems.push('dotted');
        tempPagiItems.push(numOfPage - 1);
        setPagiItems(tempPagiItems);
      } else {
        var _tempPagiItems = [];

        if (currentPage - 2 > 0) {
          if (currentPage - 2 !== 0) {
            _tempPagiItems.push(0);

            if (currentPage - 3 !== 0) {
              _tempPagiItems.push('dotted');
            }
          }

          _tempPagiItems.push(currentPage - 2);
        }

        if (currentPage - 1 > 1) {
          _tempPagiItems.push(currentPage - 1);
        }

        _tempPagiItems.push(currentPage);

        if (currentPage + 1 < numOfPage) {
          _tempPagiItems.push(currentPage + 1);
        }

        if (currentPage + 2 < numOfPage) {
          _tempPagiItems.push(currentPage + 2);

          if (currentPage + 2 !== numOfPage - 1) {
            if (currentPage + 3 < numOfPage - 1) {
              _tempPagiItems.push('dotted');
            }

            _tempPagiItems.push(numOfPage - 1);
          }
        }

        setPagiItems(_tempPagiItems);
      }
    }
  };

  useEffect(function () {
    populatePageItems();
  }, [numOfPage, currentPage]);
  return /*#__PURE__*/React.createElement(Pagination, {
    style: props.style,
    size: props.size
  }, /*#__PURE__*/React.createElement(Pagination.First, {
    onClick: function onClick() {
      updateCurrentPage(0);
    }
  }), /*#__PURE__*/React.createElement(Pagination.Prev, {
    onClick: function onClick() {
      if (currentPage > 0) {
        updateCurrentPage(currentPage - 1);
      }
    }
  }), pagiItems.map(function (i) {
    if (i === 'dotted') {
      return /*#__PURE__*/React.createElement(Pagination.Item, {
        key: Math.random(),
        disabled: true
      }, "...");
    } else {
      return /*#__PURE__*/React.createElement(Pagination.Item, {
        key: i,
        active: i === currentPage,
        onClick: handleChange
      }, i + 1);
    }
  }), /*#__PURE__*/React.createElement(Pagination.Next, {
    onClick: function onClick() {
      if (currentPage < numOfPage - 1) {
        updateCurrentPage(currentPage + 1);
      }
    }
  }), /*#__PURE__*/React.createElement(Pagination.Last, {
    onClick: function onClick() {
      updateCurrentPage(numOfPage - 1);
    }
  }));
};

export { PaginationPlus };
//# sourceMappingURL=index.modern.js.map
